using System;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Events;

namespace HelicopterMod
{
	public class HelicopterMod
	{
		public static string tag = " -FHM";
		public static void OnLoad()
		{
			ModAPI.RegisterInput("Helicopter flying up", "helicopterUp", KeyCode.W);
			ModAPI.RegisterInput("Helicopter flying down", "helicopterDown", KeyCode.X);
			ModAPI.RegisterInput("Helicopter flying right", "helicopterRight", KeyCode.D);
			ModAPI.RegisterInput("Helicopter flying left", "helicopterLeft", KeyCode.A);
		}
		public static void Main()
		{
			ModAPI.Register(
				new Modification
				{
					OriginalItem = ModAPI.FindSpawnable("Rod"),
					NameOverride = "Airbus As-350B-2 Ecureuil" + tag,
					DescriptionOverride = "",
					NameToOrderByOverride = "!",
					CategoryOverride = ModAPI.FindCategory("Vehicles"),
					ThumbnailOverride = ModAPI.LoadSprite("Textures/Helicopters/Airbus As-350B-2 Ecureuil/Thumb.png"),
					AfterSpawn = (Instance) =>
					{
						UnityEngine.Object.Destroy(Instance.GetComponent<GlowingHotMetalBehaviour>());
						UnityEngine.Object.Destroy(Instance.GetComponent<PhysicalBehaviour>());
						UnityEngine.Object.Destroy(Instance.GetComponent<AudioSource>());
						UnityEngine.Object.Destroy(Instance.GetComponent<AudioSource>());
						UnityEngine.Object.Destroy(Instance.GetComponent<Rigidbody2D>());
						UnityEngine.Object.Destroy(Instance.GetComponent<BoxCollider2D>());
						UnityEngine.Object.Destroy(Instance.GetComponent<SpriteRenderer>());
						UnityEngine.Object.Destroy(Instance.GetComponent<AudioSourceTimeScaleBehaviour>());

						Transform car = ModAPI.FindSpawnable("Car").Prefab.transform;

						GameObject body = new GameObject("Body");
						body.transform.parent = Instance.transform;
						body.transform.localScale = Vector3.one;
						body.transform.localPosition = Vector3.zero;
						SpriteRenderer bodyRenderer = body.AddComponent<SpriteRenderer>();
						bodyRenderer.sprite = ModAPI.LoadSprite("Textures/Helicopters/Airbus As-350B-2 Ecureuil/BlackColor/Body.png");
						bodyRenderer.sortingOrder = 4;
						bodyRenderer.sortingLayerName = "Foreground";
						body.layer = 9;
						PolygonCollider2D bodyCollider1 = body.AddComponent<PolygonCollider2D>();
						bodyCollider1.SetPath(0, new Vector2[]
						{
							new Vector2(8.285653f, -0.9429187f),
							new Vector2(6.541327f, 0.4730851f),
							new Vector2(5.799897f, 0.6851909f),
							new Vector2(4.038026f, 0.6848793f),
							new Vector2(0.9750977f, 0.4808655f),
							new Vector2(0.9129219f, 0.2690392f),
							new Vector2(0.5427052f, 0.1426666f),
							new Vector2(-2.255564f, 0.0851713f),
							new Vector2(-6.542835f, 0.08573969f),
							new Vector2(-7.773002f, 1.857143f),
							new Vector2(-8.314286f, 1.857143f),
							new Vector2(-7.342909f, -0.08581151f),
							new Vector2(-7.342901f, -0.22863f),
							new Vector2(-7.71413f, -0.2286489f),
							new Vector2(-7.71413f, -0.4286083f),
							new Vector2(-7.257467f, -0.4579821f),
							new Vector2(-7.311449f, -1.455651f),
							new Vector2(-7.289749f, -1.458042f),
							new Vector2(-6.806985f, -1.511219f),
							new Vector2(-6.342894f, -0.5715084f),
							new Vector2(0.8571043f, -1.285764f),
							new Vector2(3.542595f, -1.857403f),
							new Vector2(5.885649f, -1.857143f),
							new Vector2(7.799935f, -1.514336f),
							new Vector2(8.285651f, -1.200058f)
						});
						bodyCollider1.SetPath(1, new Vector2[]
						{
							new Vector2(4.599949f, -1.485772f),
							new Vector2(4.228895f, -0.2552891f),
							new Vector2(4.331542f, 0.6006578f),
							new Vector2(5.810286f, 0.6006457f),
							new Vector2(6.51852f, 0.3873698f),
							new Vector2(7.344215f, -0.2594414f),
							new Vector2(6.857727f, -0.2573929f),
							new Vector2(7.066826f, -0.7106819f),
							new Vector2(7.337837f, -0.7941818f),
							new Vector2(7.892914f, -0.8751221f),
							new Vector2(7.994019f, -1.040222f),
							new Vector2(7.999214f, -1.250751f),
							new Vector2(7.65169f, -1.48647f),
							new Vector2(7.228053f, -1.399931f)
						});
						bodyCollider1.pathCount = 2;
						BoxCollider2D bodyCollider2 = body.AddComponent<BoxCollider2D>();
						bodyCollider2.offset = new Vector2(4.814603f, -1.299858f);
						bodyCollider2.size = new Vector2(0.7335339f, 0.462059f);
						BoxCollider2D bodyCollider3 = body.AddComponent<BoxCollider2D>();
						bodyCollider3.offset = new Vector2(4.371847f, -0.441164f);
						bodyCollider3.size = new Vector2(0.2928467f, 1.257183f);
						BoxCollider2D bodyCollider4 = body.AddComponent<BoxCollider2D>();
						bodyCollider4.offset = new Vector2(6.215906f, -1.257853f);
						bodyCollider4.size = new Vector2(0.7438812f, 0.4233055f);
						BoxCollider2D bodyCollider5 = body.AddComponent<BoxCollider2D>();
						bodyCollider5.offset = new Vector2(5.899977f, -0.4436493f);
						bodyCollider5.size = new Vector2(0.1790199f, 1.322151f);
						PolygonCollider2D engineCollider = body.AddComponent<PolygonCollider2D>();
						engineCollider.SetPath(0, new Vector2[]
						{
							new Vector2(3.799889f, 1.142826f),
							new Vector2(4.455276f, 1.055313f),
							new Vector2(4.599663f, 0.8284798f),
							new Vector2(5.626915f, 0.8284302f),
							new Vector2(5.68354f, 0.6654816f),
							new Vector2(3.928017f, 0.6057091f),
							new Vector2(0.9734846f, 0.475975f),
							new Vector2(1.121876f, 0.8205376f),
							new Vector2(1.433388f, 1.117283f),
							new Vector2(1.600981f, 1.143169f)
						});
						engineCollider.pathCount = 1;
						Rigidbody2D bodyRigidbody = body.AddComponent<Rigidbody2D>();
						bodyRigidbody.mass = 29f;
						bodyRigidbody.centerOfMass = Instance.transform.localScale.x > 0f ? new Vector2(4.13f, -0.68f) : new Vector2(-4.13f, -0.68f);
						body.AddComponent<PhysicalBehaviour>().Properties = car.GetChild(0).GetComponent<PhysicalBehaviour>().Properties;
						body.AddComponent<PointToVelocityBehaviour>().direction = new Vector2(1f, 0f);

						GameObject background = new GameObject("Background");
						background.transform.parent = body.transform;
						background.transform.localScale = Vector3.one;
						background.transform.localPosition = new Vector3(6.157137f, -0.428573f);
						SpriteRenderer backgroundRenderer = background.AddComponent<SpriteRenderer>();
						backgroundRenderer.sprite = ModAPI.LoadSprite("Textures/Helicopters/Airbus As-350B-2 Ecureuil/Background.png");
						backgroundRenderer.sortingLayerName = "Bottom";

						GameObject skids = new GameObject("Skids");
						skids.transform.parent = body.transform;
						skids.transform.localScale = Vector3.one;
						skids.transform.localPosition = new Vector3(4.344162f, -2.014736f);
						SpriteRenderer skidsRenderer = skids.AddComponent<SpriteRenderer>();
						skidsRenderer.sprite = ModAPI.LoadSprite("Textures/Helicopters/Airbus As-350B-2 Ecureuil/Skids.png");
						skidsRenderer.sortingOrder = 5;
						skidsRenderer.sortingLayerName = "Foreground";
						skids.layer = 9;
						BoxCollider2D skidsCollider1 = skids.AddComponent<BoxCollider2D>();
						skidsCollider1.offset = new Vector2(0f, -0.3286161f);
						skidsCollider1.size = new Vector2(4.342857f, 0.5141964f);
						BoxCollider2D skidsCollider2 = skids.AddComponent<BoxCollider2D>();
						skidsCollider2.offset = new Vector2(-0.7144067f, 0.2094717f);
						skidsCollider2.size = new Vector2(2.343048f, 0.7524853f);
						skids.AddComponent<Rigidbody2D>().mass = 25f;
						skids.AddComponent<FixedJoint2D>().connectedBody = bodyRigidbody;
						skids.AddComponent<PhysicalBehaviour>().Properties = car.GetChild(0).GetComponent<PhysicalBehaviour>().Properties;

						GameObject frontDoor = new GameObject("FrontDoor");
						frontDoor.transform.parent = Instance.transform;
						frontDoor.transform.localScale = Vector3.one;
						frontDoor.transform.localPosition = new Vector3(6.414231f, -0.5142829f);
						SpriteRenderer frontDoorRenderer = frontDoor.AddComponent<SpriteRenderer>();
						frontDoorRenderer.sprite = ModAPI.LoadSprite("Textures/Helicopters/Airbus As-350B-2 Ecureuil/BlackColor/FrontDoor.png");
						frontDoorRenderer.sortingOrder = 5;
						frontDoorRenderer.sortingLayerName = "Foreground";
						frontDoor.layer = 10;
						PolygonCollider2D frontDoorCollider = frontDoor.AddComponent<PolygonCollider2D>();
						frontDoorCollider.SetPath(0, new Vector2[]
						{
							new Vector2(-0.07155365f, 0.8285396f),
							new Vector2(-0.3000586f, 0.942854f),
							new Vector2(-0.8428571f, 0.9428571f),
							new Vector2(-0.8428571f, 0.7999417f),
							new Vector2(-0.4143321f, -0.9428571f),
							new Vector2(0.7570182f, -0.8856863f),
							new Vector2(0.8428571f, -0.6579676f)
						});
						frontDoorCollider.pathCount = 1;
						frontDoor.AddComponent<Rigidbody2D>().mass = 0.5f;
						FixedJoint2D frontDoorFixedJoint = frontDoor.AddComponent<FixedJoint2D>();
						frontDoorFixedJoint.connectedBody = bodyRigidbody;
						frontDoorFixedJoint.breakForce = 500f;
						frontDoorFixedJoint.breakTorque = 500f;
						HingeJoint2D frontDoorHingeJoint = frontDoor.AddComponent<HingeJoint2D>();
						frontDoorHingeJoint.connectedBody = bodyRigidbody;
						frontDoorHingeJoint.breakForce = 2000f;
						frontDoorHingeJoint.breakTorque = 1500f;
						frontDoorHingeJoint.anchor = new Vector2(0.03984833f, 0.6619186f);
						frontDoorHingeJoint.useLimits = true;
						frontDoorHingeJoint.useMotor = true;
						frontDoorHingeJoint.limits = car.GetChild(5).GetComponent<HingeJoint2D>().limits;
						frontDoorHingeJoint.motor = car.GetChild(5).GetComponent<HingeJoint2D>().motor;
						frontDoor.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
						JointBreakSoundBehaviour frontDoorJointBreakSound = frontDoor.AddComponent<JointBreakSoundBehaviour>();
						frontDoorJointBreakSound.AudioSource = frontDoor.GetComponent<AudioSource>();
						frontDoorJointBreakSound.Clips = car.GetChild(5).GetComponent<JointBreakSoundBehaviour>().Clips;
						frontDoorJointBreakSound.Joints = new Joint2D[]
						{
							frontDoorHingeJoint
						};
						frontDoorJointBreakSound.OnBreak = new UnityEvent();
						frontDoorJointBreakSound.OnBreak.AddListener(() =>
						{
							frontDoorJointBreakSound.Joints = new Joint2D[0];
						});

						GameObject backDoor = new GameObject("BackDoor");
						backDoor.transform.parent = Instance.transform;
						backDoor.transform.localScale = Vector3.one;
						backDoor.transform.localPosition = new Vector3(5.142853f, -0.54286f);
						SpriteRenderer backDoorRenderer = backDoor.AddComponent<SpriteRenderer>();
						backDoorRenderer.sprite = ModAPI.LoadSprite("Textures/Helicopters/Airbus As-350B-2 Ecureuil/BlackColor/BackDoor.png");
						backDoorRenderer.sortingOrder = 5;
						backDoorRenderer.sortingLayerName = "Foreground";
						backDoor.layer = 10;
						PolygonCollider2D backDoorCollider = backDoor.AddComponent<PolygonCollider2D>();
						backDoorCollider.SetPath(0, new Vector2[]
						{
							new Vector2(-0.8857143f, 0.9714286f),
							new Vector2(-0.8857155f, 0.6852646f),
							new Vector2(-0.8857152f, 0.3999531f),
							new Vector2(-0.5429035f, -0.9714286f),
							new Vector2(0.8857143f, -0.914334f),
							new Vector2(0.4570892f, 0.9714262f)
						});
						backDoorCollider.pathCount = 1;
						backDoor.AddComponent<Rigidbody2D>().mass = 0.5f;
						FixedJoint2D backDoorFixedJoint = backDoor.AddComponent<FixedJoint2D>();
						backDoorFixedJoint.connectedBody = bodyRigidbody;
						backDoorFixedJoint.breakForce = 500f;
						backDoorFixedJoint.breakTorque = 500f;
						SliderJoint2D backDoorSliderJoint = backDoor.AddComponent<SliderJoint2D>();
						backDoorSliderJoint.connectedBody = bodyRigidbody;
						backDoorSliderJoint.autoConfigureConnectedAnchor = true;
						backDoorSliderJoint.autoConfigureAngle = false;
						backDoorSliderJoint.useMotor = true;
						backDoorSliderJoint.motor = car.GetChild(5).GetComponent<HingeJoint2D>().motor;
						backDoorSliderJoint.useLimits = true;
						backDoorSliderJoint.limits = new JointTranslationLimits2D
						{
							min = 0f,
							max = 1.26f
						};
						backDoorSliderJoint.breakForce = 2000f;
						backDoorSliderJoint.breakTorque = 1500f;
						backDoor.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
						JointBreakSoundBehaviour backDoorJointBreakSound = backDoor.AddComponent<JointBreakSoundBehaviour>();
						backDoorJointBreakSound.AudioSource = backDoor.GetComponent<AudioSource>();
						backDoorJointBreakSound.Clips = car.GetChild(5).GetComponent<JointBreakSoundBehaviour>().Clips;
						backDoorJointBreakSound.Joints = new Joint2D[]
						{
							backDoorSliderJoint
						};
						backDoorJointBreakSound.OnBreak = new UnityEvent();
						backDoorJointBreakSound.OnBreak.AddListener(() =>
						{
							backDoorJointBreakSound.Joints = new Joint2D[0];
						});
						HelicopterDoorBehaviour backDoorBehaviour = backDoor.AddComponent<HelicopterDoorBehaviour>();
						backDoorBehaviour.Slider = backDoorSliderJoint;
						backDoorBehaviour.Fixed = backDoorFixedJoint;

						GameObject propeller = new GameObject("Propeller");
						propeller.transform.parent = body.transform;
						propeller.transform.localScale = Vector3.one;
						propeller.transform.localPosition = new Vector3(3.728569f, 1.414279f);
						propeller.AddComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Helicopters/Airbus As-350B-2 Ecureuil/Propeller1.png");
						propeller.layer = 9;
						propeller.AddComponent<BoxCollider2D>();
						propeller.AddComponent<Rigidbody2D>().mass = 1f;
						propeller.AddComponent<FixedJoint2D>().connectedBody = bodyRigidbody;
						propeller.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
						DamagableMachineryBehaviour propellerDamagable = propeller.AddComponent<DamagableMachineryBehaviour>();
						propellerDamagable.CanRepair = false;
						propellerDamagable.IndestructibilityCanBeToggled = false;
						propellerDamagable.Health = 10f;
						propellerDamagable.BehavioursToToggle = new MonoBehaviour[0];
						propellerDamagable.GameObjectsToToggle = new GameObject[0];
						propellerDamagable.ExplodesOnBreak = true;
						propellerDamagable.FirearmDamageMultiplier = 0.5f;
						propellerDamagable.ExplosionDamageMultiplier = 2.5f;
						propellerDamagable.FireDamageThreshold = 1f;
						propellerDamagable.FragmentForce = 1f;
						propellerDamagable.ExplosionRange = 10f;
						propellerDamagable.Waterproof = false;
						propellerDamagable.ExplosionPrefab = ModAPI.FindSpawnable("Generator").Prefab.GetComponent<DamagableMachineryBehaviour>().ExplosionPrefab;

						GameObject propellerBlade1 = new GameObject("Blade1");
						propellerBlade1.transform.parent = propeller.transform;
						propellerBlade1.transform.localScale = Vector3.one;
						propellerBlade1.transform.localPosition = new Vector3(0f, 0.242857f);
						SpriteRenderer propellerBlade1Renderer = propellerBlade1.AddComponent<SpriteRenderer>();
						propellerBlade1Renderer.sprite = ModAPI.LoadSprite("Textures/Helicopters/Airbus As-350B-2 Ecureuil/Propeller1Blade.png");
						propellerBlade1Renderer.flipX = true;

						GameObject propellerBlade2 = new GameObject("Blade2");
						propellerBlade2.transform.parent = propeller.transform;
						propellerBlade2.transform.localScale = Vector3.one;
						propellerBlade2.transform.localPosition = new Vector3(0f, 0.242857f);
						SpriteRenderer propellerBlade2Renderer = propellerBlade2.AddComponent<SpriteRenderer>();
						propellerBlade2Renderer.sprite = ModAPI.LoadSprite("Textures/Helicopters/Airbus As-350B-2 Ecureuil/Propeller1Blade.png");

						HelicopterPropellerBehaviour propellerBehaviour = propeller.AddComponent<HelicopterPropellerBehaviour>();
						propellerBehaviour.FirstBladeRenderer = propellerBlade1Renderer;
						propellerBehaviour.SecondBladeRenderer = propellerBlade2Renderer;

						GameObject propeller2 = new GameObject("Propeller2");
						propeller2.transform.parent = body.transform;
						propeller2.transform.localScale = Vector3.one;
						propeller2.transform.localPosition = new Vector3(-6.217834f, -0.1427345f);
						propeller2.AddComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Helicopters/Airbus As-350B-2 Ecureuil/Propeller2.png");
						CosmeticRotationBehaviour propeller2Animation = propeller2.AddComponent<CosmeticRotationBehaviour>();
						propeller2Animation.Acceleration = 0.2f;
						propeller2Animation.RotationSpeedTarget = -5500f;
						propeller2Animation.Dampening = 0.5f;

						GameObject smoke = UnityEngine.Object.Instantiate(car.GetChild(7).GetChild(0).gameObject);
						smoke.transform.parent = body.transform;
						smoke.transform.localScale = Vector3.one;
						smoke.transform.localPosition = new Vector3(0.54f, 0.46f);

						AudioSource audio = body.AddComponent<AudioSource>();
						audio.loop = true;
						audio.clip = ModAPI.LoadSound("Sounds/Propeller.wav");
						audio.spread = 0f;
						audio.volume = 1f;
						audio.minDistance = 10f;
						audio.spatialBlend = 1f;
						audio.dopplerLevel = 1f;

						Sprite blackFrontDoor = ModAPI.LoadSprite("Textures/Helicopters/Airbus As-350B-2 Ecureuil/BlackColor/FrontDoor.png");
						Sprite whiteBackDoor = ModAPI.LoadSprite("Textures/Helicopters/Airbus As-350B-2 Ecureuil/WhiteColor/BackDoor.png");
						
						RandomHelicopterTextureBehaviour randomHelicopterTexture = body.AddComponent<RandomHelicopterTextureBehaviour>();
						randomHelicopterTexture.FrontDoorRenderer = frontDoorRenderer;
						randomHelicopterTexture.BackDoorRenderer = backDoorRenderer;
						randomHelicopterTexture.Textures = new RandomHelicopterTextureBehaviour.HelicopterSprites[]
						{
							new RandomHelicopterTextureBehaviour.HelicopterSprites
							{
								Body = ModAPI.LoadSprite("Textures/Helicopters/Airbus As-350B-2 Ecureuil/BlackColor/Body.png"),
								FrontDoor = blackFrontDoor,
								BackDoor = ModAPI.LoadSprite("Textures/Helicopters/Airbus As-350B-2 Ecureuil/BlackColor/BackDoor.png")
							},
							new RandomHelicopterTextureBehaviour.HelicopterSprites
							{
								Body = ModAPI.LoadSprite("Textures/Helicopters/Airbus As-350B-2 Ecureuil/WhiteColor/Body.png"),
								FrontDoor = ModAPI.LoadSprite("Textures/Helicopters/Airbus As-350B-2 Ecureuil/WhiteColor/FrontDoor.png"),
								BackDoor = whiteBackDoor
							}
						};

						List<ContextMenuButton> menuButtons = body.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons;
						ContextMenuButton? menuButton = null;
						Sprite policeBodySprite = ModAPI.LoadSprite("Textures/Helicopters/Airbus As-350B-2 Ecureuil/PoliceBody.png");
						menuButton = new ContextMenuButton("setAsPolice", "Set as police", "Makes the helicopter a police", () =>
						{
							menuButtons.Remove(menuButton.Value);
							menuButtons.Remove(menuButtons.Find((x) => x.Identity == "nextSkin"));
							menuButtons.Remove(menuButtons.Find((x) => x.Identity == "previousSkin"));
							body.GetComponent<SpriteRenderer>().sprite = policeBodySprite;
							if (randomHelicopterTexture.textureIndex == 0)
							{
								backDoor.GetComponent<SpriteRenderer>().sprite = whiteBackDoor;
							}
							else
							{
								frontDoor.GetComponent<SpriteRenderer>().sprite = blackFrontDoor;
							}
							UnityEngine.Object.Destroy(randomHelicopterTexture);
						});
						menuButtons.Add(menuButton.Value);

						HelicopterBehaviour helicopterBehaviour = body.AddComponent<HelicopterBehaviour>();
						helicopterBehaviour.EngineCollider = engineCollider;
						helicopterBehaviour.Audio = audio;
						helicopterBehaviour.Smoke = smoke.GetComponent<ParticleSystem>();
						helicopterBehaviour.PropellerRotation = propeller2Animation;
						helicopterBehaviour.Propeller = propellerBehaviour;
						helicopterBehaviour.Health = 100f;
						helicopterBehaviour.FirearmDamageMultiplier = 0.2f;
						helicopterBehaviour.CollisionDamageMultiplier = 5f;
						helicopterBehaviour.BreakingThreshold = 25f;
						helicopterBehaviour.RayPosition = new Vector3(4.23f, -2.60045f);
						helicopterBehaviour.Center = 2.65f;

						NoCollide noCollide = Instance.AddComponent<NoCollide>();
						noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
						noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
					}
				}
			);
		}
	}
	public class HelicopterBehaviour : MonoBehaviour
	{
		private void Start()
		{
			rigidbody = GetComponent<Rigidbody2D>();
			GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("setHeight", "Set height", "Sets height", new UnityAction[]
			{
				() =>
				{
					DialogBox dialog = null;
					dialog = DialogBoxManager.TextEntry("Set height\n<color=green><size=26>Currently: " + Height * Utils.UnitsToMeters + "(meters)</size></color>", "Height", new DialogButton[]
					{
						new DialogButton("Apply", true, () =>
						{
							float newHeight;
							if (float.TryParse(dialog.EnteredText, out newHeight))
							{
								Height = newHeight * Utils.MetersToUnits;
							}
						}),
						new DialogButton("Cancel", true)
					});
				}
			})
			{
				Condition = () => !Broken
			});
			GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("toggleContol", () =>
			{
				if (Controlled)
				{
					return "Disable control";
				}
				return "Enable control";
			}, "Toggles control", new UnityAction[]
			{
				() =>
				{
					switch (Controlled)
					{
						case true:
							Controlled = false;
							break;
						case false:
							Controlled = true;
							if (!Activated)
							{
								Height = 0.1f;
							}
							break;
					}
				}
			})
			{
				Condition = () => !Broken
			});
			GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("toggleShutoffEngineWhenOnGround", () =>
            {
				if (ShutoffEngineWhenOnGround)
                {
					return "Leave enabled the engine on the ground";
                }
				return "Shutoff the engine on the ground";
            }, "Toggles whether to shutoff the engine when on the ground", new UnityAction[]
			{
				() =>
				{
					ShutoffEngineWhenOnGround = !ShutoffEngineWhenOnGround;
				}
			})
			{
				Condition = () => !Broken
			});
			transform.parent.gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
			UpdateActivation();
		}
		private void Use()
		{
			Activated = !Activated;
			UpdateActivation();
		}
		private void UpdateActivation()
		{
			if (Activated && !Broken)
			{
				PropellerRotation.ShouldRotate = true;
				Propeller.Activated = true;
				Audio.Play();
			}
			else
			{
				PropellerRotation.ShouldRotate = false;
				Propeller.Activated = false;
				Audio.Stop();
			}
			if (Broken)
			{
				Activated = false;
				PropellerRotation.ShouldRotate = false;
				Propeller.Activated = false;
				Propeller.GetComponent<DamagableMachineryBehaviour>().Health = 0f;
				Propeller.GetComponent<DamagableMachineryBehaviour>().SendMessage("ActOnDamage", SendMessageOptions.DontRequireReceiver);
				Audio.Stop();
				Smoke.Play();
			}
		}
		private void FixedUpdate()
		{
			if (Activated)
			{
				RaycastHit2D raycast = Physics2D.Raycast(transform.TransformPoint(RayPosition), transform.TransformDirection(-transform.up), Mathf.Infinity, LayerMask.GetMask("Objects", "Bounds", "CollidingDebris"));
				time += 0.05f;
				if (time > 3f)
				{
					surfaceHeight = raycast.point.y + Center;
					float roundedSurfaceHeight = (float)Math.Round(surfaceHeight, 3);
					if (notUpdatedSurfaceHeight == 0f)
					{
						notUpdatedSurfaceHeight = roundedSurfaceHeight;
					}
					if (notUpdatedSurfaceHeight != roundedSurfaceHeight)
					{
						notUpdatedSurfaceHeight = roundedSurfaceHeight;
						Height = raycast.distance;
					}
					float force = surfaceHeight + Height - transform.position.y;
					if (force > 10f)
					{
						force = 10f;
					}
					if (force < -10f)
					{
						force = -10f;
					}
					if (force >= 0f)
					{
						if (rigidbody.velocity.y >= force)
						{
							if (rigidbody.velocity.y < 0f)
							{
								rigidbody.AddForce(new Vector2(0f, 850f));
							}
							else
							{
								rigidbody.velocity = new Vector2(rigidbody.velocity.x, force);
							}
						}
						else
						{
							rigidbody.AddForce(new Vector2(0f, 1000f));
						}
					}
					else
					{
						if (rigidbody.velocity.y <= force)
						{
							if (rigidbody.velocity.y > 0f)
							{
								rigidbody.AddForce(new Vector2(0f, -850f));
							}
							else
							{
								rigidbody.velocity = new Vector2(rigidbody.velocity.x, force);
							}
						}
						else
						{
							rigidbody.AddForce(new Vector2(0f, -1000f));
						}
					}
					float velX = Mathf.Round(rigidbody.velocity.x);
					if (velX == 0f)
					{
						rigidbody.MoveRotation(Mathf.LerpAngle(rigidbody.rotation, 0f, Time.fixedDeltaTime));
					}
					else if (velX > 0f)
					{
						rigidbody.MoveRotation(Mathf.LerpAngle(rigidbody.rotation, -4.43f, Time.fixedDeltaTime));
					}
					else
					{
						rigidbody.MoveRotation(Mathf.LerpAngle(rigidbody.rotation, 4.43f, Time.fixedDeltaTime));
					}
					rigidbody.angularVelocity = 0f;
					if (Controlled)
					{
						if (InputSystem.Held("helicopterUp"))
						{
							Height += 0.1f;
						}
						if (InputSystem.Held("helicopterDown"))
						{
							Height -= 0.1f;
							if (Height <= 0f)
							{
								Height = 0f;
								if (ShutoffEngineWhenOnGround)
								{
									Activated = false;
									UpdateActivation();
								}
							}
						}
						if (InputSystem.Held("helicopterRight"))
						{
							rigidbody.AddForce(new Vector2(150f, 0f));
						}
						if (InputSystem.Held("helicopterLeft"))
						{
							rigidbody.AddForce(new Vector2(-150f, 0f));
						}
					}
				}
			}
			else
			{
				if (InputSystem.Held("helicopterUp") && Controlled)
				{
					Activated = true;
					UpdateActivation();
				}
			}
			if (!Broken && Propeller.GetComponent<DamagableMachineryBehaviour>().Destroyed || Health <= 0f)
			{
				Broken = true;
				Health = 0f;
				UpdateActivation();
			}
		}
		private void OnCollisionEnter2D(Collision2D collision)
		{
			if (EngineCollider.IsTouching(collision.otherCollider) && collision.GetContact(0).normalImpulse > BreakingThreshold / 2f)
			{
				Health -= collision.GetContact(0).normalImpulse * CollisionDamageMultiplier * 3f;
				return;
			}
			if (collision.GetContact(0).normalImpulse > BreakingThreshold)
			{
				Health -= collision.GetContact(0).normalImpulse * CollisionDamageMultiplier;
			}
		}
		private void Shot(Shot shot)
		{
			if (EngineCollider.bounds.Contains(shot.point))
			{
				Health -= shot.damage * FirearmDamageMultiplier;
			}
		}
		private void OnFragmentHit()
		{
			Health = 0f;
		}

		public bool Activated;
		public bool Broken;
		public bool Controlled;
		public bool ShutoffEngineWhenOnGround = true;
		private Rigidbody2D rigidbody;
		[SkipSerialisation]
		public Collider2D EngineCollider;
		[SkipSerialisation]
		public AudioSource Audio;
		[SkipSerialisation]
		public ParticleSystem Smoke;
		[SkipSerialisation]
		public CosmeticRotationBehaviour PropellerRotation;
		[SkipSerialisation]
		public HelicopterPropellerBehaviour Propeller;
		public float Height = 25f;
		public float Health;
		public float BreakingThreshold;
		public float FirearmDamageMultiplier;
		public float CollisionDamageMultiplier;
		public float Center;
		private float time;
		private float surfaceHeight;
		private float notUpdatedSurfaceHeight;
		public Vector3 RayPosition;
	}
	public class HelicopterPropellerBehaviour : MonoBehaviour
    {
		private void Update()
        {
			float deltaTime = Time.deltaTime;
			if (Activated)
			{
				spinSpeed = Mathf.Lerp(spinSpeed, 40f, Utils.GetLerpFactorDeltaTime(0.9f, deltaTime));
			}
			else
			{
				spinSpeed = Mathf.Lerp(spinSpeed, 0f, Utils.GetLerpFactorDeltaTime(0.9f, deltaTime));
			}

			if (spinSpeed < 0f)
			{
				spinSpeed = 0f;
			}

			deltaTime *= spinSpeed;
			flipClock += deltaTime;
			clock += deltaTime;
			if (flipClock >= (float)Math.PI / 2f)
			{
				FirstBladeRenderer.sortingOrder = (!flip) ? 1 : (-1);
				SecondBladeRenderer.sortingOrder = flip ? 1 : (-1);
				flipClock %= (float)Math.PI / 2f;
				flip = !flip;
			}

			Vector3 localScale = new Vector3(Mathf.Abs(Mathf.Sin(clock + (float)Math.PI / 2f)), 1f, 1f);
			FirstBladeRenderer.transform.localScale = localScale;
			SecondBladeRenderer.transform.localScale = localScale;
		}

		public bool Activated;
		private bool flip;
		[SkipSerialisation]
		public SpriteRenderer FirstBladeRenderer;
		[SkipSerialisation]
		public SpriteRenderer SecondBladeRenderer;
		private float flipClock;
		private float clock;
		private float spinSpeed;
    }
	public class HelicopterDoorBehaviour : MonoBehaviour
    {
		private void Use()
        {
			Activated = !Activated;
        }
		private void FixedUpdate()
		{
			if (!Broken)
			{
				Slider.motor = new JointMotor2D
				{
					maxMotorTorque = Slider.motor.maxMotorTorque,
					motorSpeed = Activated ? Slider.limitState == JointLimitState2D.UpperLimit ? 0f : 1f : Slider.limitState == JointLimitState2D.LowerLimit ? 0f : -1f
				};
				Fixed.enabled = !Activated && Slider.limitState == JointLimitState2D.LowerLimit;
			}
		}
		private void OnJointBreak2D(Joint2D joint)
        {
			if (joint == Fixed)
			{
				Broken = true;
			}
			else if (joint == Slider && !Broken)
            {
				Broken = true;
				Destroy(Fixed);
            }
        }

		public bool Activated;
		public bool Broken;
		[SkipSerialisation]
		public FixedJoint2D Fixed;
		[SkipSerialisation]
		public SliderJoint2D Slider;
    }
	public class RandomHelicopterTextureBehaviour : MonoBehaviour
    {
		private void Start()
        {
			bodyRenderer = GetComponent<SpriteRenderer>();
			PhysicalBehaviour phys = GetComponent<PhysicalBehaviour>();
			phys.ContextMenuOptions.Buttons.Add(new ContextMenuButton("nextSkin", "Next texture", "Switches to the next texture", () =>
            {
				textureIndex++;
				SetTextureToIndex();
            }));
			phys.ContextMenuOptions.Buttons.Add(new ContextMenuButton("previousSkin", "Previous texture", "Switches to the previous texture", () =>
			{
				textureIndex--;
				SetTextureToIndex();
			}));
			if (textureIndex == -1)
            {
				textureIndex = UnityEngine.Random.Range(0, Textures.Length);
            }
			SetTextureToIndex();
		}
		private void SetTextureToIndex()
        {
			if (textureIndex > Textures.Length - 1)
            {
				textureIndex = 0;
            }
			if (textureIndex < 0)
            {
				textureIndex = Textures.Length - 1;
            }
			bodyRenderer.sprite = Textures[textureIndex].Body;
			FrontDoorRenderer.sprite = Textures[textureIndex].FrontDoor;
			BackDoorRenderer.sprite = Textures[textureIndex].BackDoor;
        }

		private SpriteRenderer bodyRenderer;
		[SkipSerialisation]
		public SpriteRenderer FrontDoorRenderer;
		[SkipSerialisation]
		public SpriteRenderer BackDoorRenderer;
		[SkipSerialisation]
		public HelicopterSprites[] Textures;
		public int textureIndex = -1;
		public struct HelicopterSprites
        {
			public Sprite Body;
			public Sprite FrontDoor;
			public Sprite BackDoor;
        }
    }
}
	


